/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 *********************************************************************/

#include "constants.h"

#ifdef USE_UI_GTK

#include "XGtkLabelCombo.h"

#include "../../../misc/language.h"

namespace GTK_DOKO
{

  /*****************************************************************************
   *
   * XGtkLabelCombo::XGtkLabelCombo(string const& text)
   *
   * Parameters:	text - text for the label
   *
   * Result:	-
   * 
   * Version:	0.4.3
   *
   * Description:	Constructor
   *
   ****************************************************************************/
  XGtkLabelCombo::XGtkLabelCombo(string const& text) :
    XGtkLabelWidget(text),
  combo_p(gtk_combo_new()) // the combo
  {
    DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_INIT,
		  "XGtkLabelCombo::XGtkLabelCombo()");

    gtk_box_pack_end(GTK_BOX(this->container()),
		     this->combo(),
		     TRUE, TRUE, 0);

    // set the text of the label widget
    this->language_update();

    // show all widgets
    gtk_widget_show_all(this->widget());

    DEBUG_RETURNING(VOID,
		    INFO_GTK_WIDGET && INFO_GTK_INIT,
		    "XGtkLabelCombo::XGtkLabelCombo()");
  } // XGtkLabelCombo::XGtkLabelCombo()

  /*****************************************************************************
   *
   * XGtkLabelCombo::~XGtkLabelCombo()
   *
   * Parameters:	-
   *
   * Result:	-
   * 
   * Version:	0.4.3
   *
   * Description:	Destructor
   *
   ****************************************************************************/
  XGtkLabelCombo::~XGtkLabelCombo()
  {
    DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_INIT,
		  "XGtkLabelCombo::~XGtkLabelCombo()");

    gtk_widget_destroy(this->combo());

    DEBUG_RETURNING(VOID,
		    INFO_GTK_WIDGET && INFO_GTK_INIT,
		    "XGtkLabelCombo::~XGtkLabelCombo()");
  } // XGtkLabelCombo::XGtkLabelCombo()

  /*****************************************************************************
   *
   * GtkWidget* XGtkLabelCombo::combo()
   *
   * Parameters:	-
   *
   * Result:	the combo
   *
   * Version:	0.4.3
   *
   * Description:	Result
   *
   ****************************************************************************/
  GtkWidget*
    XGtkLabelCombo::combo()
    {
      DEBUG_CALLING(INFO_GTK_WIDGET && INFO_GTK_VALUE,
		    "XGtkLabelCombo::combo()");

      DEBUG_ASSERTION((this->combo_p != NULL),
		      "XGtkLabelCombo::combo()\n"
		      "  `combo_p` == NULL");

      DEBUG_RETURNING(this->combo_p,
		      INFO_GTK_WIDGET && INFO_GTK_VALUE,
		      "XGtkLabelCombo::combo()");
    } // GtkWidget* XGtkLabelCombo::combo()

}
#endif
